## com.google.javascript.jscomp.deps
Class JsFileParser

    java.lang.Object
      com.google.javascript.jscomp.deps.JsFileLineParser
          com.google.javascript.jscomp.deps.JsFileParser

    public class JsFileParser

extends JsFileLineParser

A parser that can extract goog.require() and goog.provide() dependency information from a .js file.

Constructor Summary
`JsFileParser(ErrorManager errorManager)` Constructor

Method Summary
`DependencyInfo` | `parseFile(String filePath, String closureRelativePath)` Parses the given file and returns the dependency information that it contained.
`DependencyInfo` | `parseFile(String filePath, String closureRelativePath, String fileContents)` Parses the given file and returns the dependency information that it contained.
`protected boolean` | `parseLine(String line)` Parses a line of javascript, extracting goog.provide and goog.require information.

Methods inherited from class com.google.javascript.jscomp.deps.JsFileLineParser
`didParseSucceed, setShortcutMode`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JsFileParser

    public JsFileParser(ErrorManager errorManager)

  Constructor

  Parameters:
    `errorManager` - Handles parse errors.

Method Detail

### parseFile

    public DependencyInfo parseFile(String filePath,
                                    String closureRelativePath)
                             throws IOException

  Parses the given file and returns the dependency information that it contained.

  Parameters:
    `filePath` - Path to the file to parse.
    `closureRelativePath` - Path of the file relative to closure.
  Returns:
    A DependencyInfo containing all provides/requires found in the file.
  Throws:
    `IOException` - Thrown if there was an problem reading the given file.

### parseFile

    public DependencyInfo parseFile(String filePath,
                                    String closureRelativePath,
                                    String fileContents)

  Parses the given file and returns the dependency information that it contained.

  Parameters:
    `filePath` - Path to the file to parse.
    `closureRelativePath` - Path of the file relative to closure.
    `fileContents` - The contents to parse.
  Returns:
    A DependencyInfo containing all provides/requires found in the file.

### parseLine

    protected boolean parseLine(String line)
                         throws com.google.javascript.jscomp.deps.JsFileLineParser.ParseException

  Parses a line of javascript, extracting goog.provide and goog.require information.

  Parameters:
    `line` - The line to parse.
  Returns:
    true to keep going, false otherwise.
  Throws:
    `com.google.javascript.jscomp.deps.JsFileLineParser.ParseException`